> module Bindings (tick,display,reshape,keyboardMouse) where
> import Graphics.Rendering.OpenGL
> import Graphics.UI.GLUT
> import System.Exit
> import Data.IORef
> import Control.Monad
> import qualified Musicwrapper
> import Display
> import Grid
> import Entities
> import Maths
> import Texts

> reshape :: Size -> IO()
> reshape s = do 
>  viewport $= (Position 0 0, s)

> movePlayer :: IORef (GameState) -> Int -> IO()
> movePlayer gamestate a = do
>   GameState{player=Entity{pos=pa}, level=l} <-  get (gamestate)
>   modifyIORef gamestate 
>                   (\g@GameState{player=e@Entity{pos=p, engine=eng}}->g{player=e{pos=trans p a 0, engine=eng}}) 

> setEngine :: IORef (GameState) ->  Bool -> IO()
> setEngine gamestate eng = do
>   GameState{player=Entity{pos=pa}, level=l} <-  get (gamestate)
>   modifyIORef gamestate 
>                   (\g@GameState{player=e@Entity{pos=p}}->g{player=e{pos=p, engine=eng}}) 

> yDelta :: GLfloat
> yDelta = 0.02

--could functionalize/purify this a lot more

> keyboardAct :: IORef (GameState) -> Key -> KeyState -> IO()
> keyboardAct gamestate (SpecialKey KeyLeft) Down = 
>     movePlayer gamestate (-1) 
> keyboardAct gamestate (SpecialKey KeyRight) Down = 
>     movePlayer gamestate 1
> keyboardAct gamestate (SpecialKey KeyUp) Down = 
>     setEngine gamestate True
> keyboardAct gamestate (SpecialKey KeyDown) Down = 
>     setEngine gamestate False
> keyboardAct gamestate (Char ' ') Up = do
>                                       gmst@GameState{title=t, score=sc} <- readIORef  gamestate
>                                       if (sc) < (length introText)
>                                           then modifyIORef gamestate (\gs@GameState{score=sc}-> gs{score=sc+1} )
>                                           else modifyIORef gamestate (\gs@GameState{gen=g}->initialState (shuffle g) False 0 )
> keyboardAct gamestate (Char 'q') Up = 
>    quit
> keyboardAct gamestate (Char 'Q') Up = 
>    quit
> keyboardAct gamestate (Char '\ESC') Up = 
>    quit

 keyboardAct gamestate (SpecialKey KeyUp) Down = 
     movePlayer gamestate 0 (-yDelta)
 keyboardAct gamestate (SpecialKey KeyDown) Down = 
     movePlayer gamestate 0 (yDelta)

> keyboardAct gamestate _ _   = 
>     return()


> quit :: IO()
> quit = do
>        Musicwrapper.release_sound
>        exitWith ExitSuccess


> keyboardMouse :: IORef (GameState) -> Key -> KeyState -> Modifiers -> t1 -> IO()
> keyboardMouse  pos key state modifiers position = 
>     keyboardAct  pos key state
