{-
FIX RANDOM GENERATION...ALL LEVELS ARE CURRENTLY THE SAME!

-}

> module Display (display,tick) where
> import Graphics.Rendering.OpenGL
> import Graphics.Rendering.OpenGL.GL.StateVar
> import Graphics.UI.GLUT.Fonts

> import Graphics.UI.GLUT
> import qualified Musicwrapper
> import System.Random
> import Data.IORef
> import Points
> import Consts
> import Entities
> import Texts
> import Colors 
> import Treestructs2
> import Treepopulate
> import Data.Fixed
> import Maths

draw a cube

> cube :: GLfloat-> IO ()
> cube w = do 
>   renderPrimitive Quads $ do
>     vertex $ Vertex2 w w
>     vertex $ Vertex2 w (-w) 
>     vertex $ Vertex2 (-w) (-w)
>     vertex $ Vertex2 (-w) w 


> delta :: GLfloat
> delta = 0.3;

> data StripData = StripData {
>       heights :: (GLfloat, GLfloat),
>       eType :: EntityType
>       }

> choosedata :: Maybe StripData -> Maybe StripData -> Maybe StripData
> choosedata (Just d) Nothing = Just d
> choosedata Nothing (Just d) = Just d
> choosedata Nothing Nothing = Nothing

--true when no collision occurs

> collide :: StripData -> GLfloat -> GLfloat -> Bool
> collide StripData{heights=(t,b),eType=E_Tree} py time = if  (((py-pHeight<eTop)&&(py+pHeight>eBottom)) || ((py+pHeight>eBottom)&&(py-pHeight<eTop)))
>                                                         then False
>                                                         else True
>                                                             where
>                                                             eTop= b+(t-b)* (  min ((time `mod'` 250)/100) 100)
>                                                             eBottom= b+(t-b)* (  max (((time `mod'` 250)-100)/100) 0)
> collide StripData{heights=(t,b),eType=E_Waterfall} py time = if  ((py-pHeight<eLoc)&&(py+pHeight>eLoc))
>                                                         then False
>                                                         else True
>                                                             where
>                                                             eLoc= t+(b-t)* (  max (((time `mod'` 160)-80)/80) 0)
> collide StripData{eType=E_None} _ _ = True                                       

> drawTitle :: Int -> IO()
> drawTitle n =  if (n==0) then do
>                               renderPrimitive Lines $ do
>                                                       color $ white
>                                                       vertex $ Vertex2 (0::GLfloat) 1
>                                                       color $ blue
>                                                       vertex $ Vertex2 0 (-0.5::GLfloat)
>                                                       color $ blue
>                                                       vertex $ Vertex2 (-1) (-0.5::GLfloat) 
>                                                       vertex $ Vertex2 1 (-0.5::GLfloat)
>                               preservingMatrix $ do 
>                                                  translate $ Vector3 (-0.9) (-0.8::GLfloat) 0
>                                                  color $ blue
>                                                  sequence_ $ map printSquare $ textCoords
>                else
>                preservingMatrix $ do
>                                   translate $ Vector3 (-1) (0.7) (-1::GLfloat)
>                                   scale (0.0004::GLfloat) 0.0004 0.0004
>                                   printText (introText!!(n-1))

> titleText :: [[Int]]
> titleText = [
>  [1,1,1,0,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,1,1,0,1,1,1,0,0,1,0,0,1,1,1,0,1,1,1,0],
>  [1,0,1,0,1,0,1,0,1,0,1,0,1,0,0,0,1,0,0,0,0,0,0,1,0,0,0,1,0,1,0,1,0,1,0,1,0,0,0,1,0,1,0],
>  [1,1,1,0,1,1,0,0,1,1,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,1,0,1,1,1,0,1,1,1,0,1,0,0,0,1,1,0,0],
>  [1,0,0,0,1,0,1,0,1,1,1,0,1,1,0,0,1,1,0,0,0,0,0,1,1,0,0,1,0,0,0,1,0,1,0,1,1,1,0,1,1,1,0]
>  ]

> printText :: [String] -> IO()
> printText (s:ss) = do
>                    preservingMatrix $ do 
>                                       renderString MonoRoman (s)
>                    preservingMatrix $ do 
>                                       translate $ Vector3 (0::GLfloat) (-200) 0.0
>                                       printText ss
> printText [] = return()


> textCoords :: [(Int,Int)]
> textCoords = [(i,j)|i<-[0..(length ((titleText!!0))-1)],j<-[0..((length titleText) - 1)], titleText !! j !! i == 1]

> boxWidth :: GLfloat
> boxWidth = 0.03;

> printSquare :: (Int,Int) -> IO()
> printSquare (x,y) = renderPrimitive Polygon $ do 
>                                               vertex $ Vertex2 x' (y'+boxWidth)
>                                               vertex $ Vertex2 (x'+boxWidth) (y'+boxWidth)
>                                               vertex $ Vertex2 (x'+boxWidth) y'
>                                               vertex $ Vertex2 x' y'
>                     where
>                       x' = (fromIntegral x)*boxWidth
>                       y' = -(fromIntegral y)*boxWidth

> drawEntity ::  (GLfloat,GLfloat,EntityType) -> GLfloat-> GLfloat -> GLfloat -> IO()
> drawEntity (t,b, E_None) x s time = return()
> drawEntity (t,b, E_Tree) x s time = do
>                                     renderPrimitive Lines $ do
>                                                             color $ black
>                                                             vertex $ Vertex2 x (-b+h1)
>                                                             vertex $ Vertex2 x (-b+h2)
>                                     if (s<0.5^maxHeight) then renderPrimitive Lines $ do
>                                            vertex $ Vertex2 (x-s) (-b+h1)
>                                            vertex $ Vertex2 (x+s) (-b+h1)
>                                            vertex $ Vertex2 (x-s) (-b+h2)
>                                            vertex $ Vertex2 (x+s) (-b+h2)
>                                            else
>                                            return() 
>                                         where
>                                         h1=(t+b)* (  max (((time `mod'` 250)-100)/100) 0)
>                                         h2= (t+b)* (  min ((time `mod'` 250)/100) 100)
> drawEntity (t,b, E_Waterfall) x s time =
>                                     if (s<0.5^maxHeight) then renderPrimitive Lines $ do
>                                                                                       color $ lightblue
>                                                                                       vertex $ Vertex2 (x-s) (t-h1)
>                                                                                       vertex $ Vertex2 (x+s) (t-h1)
>                                                                                       vertex $ Vertex2 (x-s) (t)
>                                                                                       vertex $ Vertex2 (x+s) (t)

                                                                                       vertex $ Vertex2 (x-s) (t-h2)
                                                                                       vertex $ Vertex2 (x+s) (t-h2)

>                                     else return() 
>                                         where
>                                         h1=(t+b)* (  max (((time `mod'` 160)-80)/80) 0)



> drawTree :: Tree (GLfloat,GLfloat,EntityType)  -> Vertex2 GLfloat -> GLfloat -> GLfloat -> IO(Maybe StripData)
> drawTree (Fork _ ta tb) (Vertex2 x y) s t = do

                             renderPrimitive Lines $ do
                                                     vertex $ Vertex2 x y
                                                     vertex $ Vertex2 x (y-delta)
                                                     vertex $ Vertex2 (x-s) (y-delta)
                                                     vertex $ Vertex2 (x+s) (y-delta)

>                             a<-drawTree ta (Vertex2 (x-s) (y-delta)) (s/2) t
>                             b<-drawTree tb (Vertex2 (x+s) (y-delta)) (s/2) t
>                             return $ choosedata a  b
> drawTree (Leaf dat@(a,b,_)) (Vertex2 x y) s t = do
>                                             renderPrimitive Polygon $ do
>                                                                       color $ Color3 0 0 (1/(1+100*s))
>                                                                       vertex $ Vertex2 (x-2.01*s) a
>                                                                       vertex $ Vertex2 (x+2.01*s) a
>                                                                       vertex $ Vertex2 (x+2.01*s) (-b)
>                                                                       vertex $ Vertex2 (x-2.01*s) (-b)
>                                             drawEntity dat x s t
>                                             return (Nothing)
> drawTree (Player dat@(a,b,ent)) (Vertex2 x y) s t = do
>                                                 renderPrimitive Polygon $ do
>                                                                           color $ Color3 0 0 (1/(1+100*s))
>                                                                           vertex $ Vertex2 (x-2.01*s) a
>                                                                           vertex $ Vertex2 (x+2.01*s) a
>                                                                           vertex $ Vertex2 (x+2.01*s) (-b)
>                                                                           vertex $ Vertex2 (x-2.01*s) (-b)
>                                                 drawEntity dat x s t
>                                                 return (Just StripData{heights=(a,-b),eType=ent })
>                             

 spacePoints (px,py) (SpaceTime st) = [(c,Vector3 ((fromIntegral x)*tilesize) ((fromIntegral y)*tilesize) (0.0::GLfloat))|(x,y,c)<-h]
                              where (Space h)=head st

> pHeight :: GLfloat
> pHeight = 0.0375

> offset :: GLfloat
> offset = 1 - (1/2)^^(maxHeight)

> display :: IORef(GameState) -> IO ()
> display gamestate = do 
>   clear [ColorBuffer]
>   loadIdentity
>   GameState{player=Entity{pos=(px,py)},  level=l, gen=g, score=s, maxscore=ms, time=t, title=tit} <-  get (gamestate)
>   if (tit) 
>       then do 
>            drawTitle s
>       else do
>            preservingMatrix $ do 
>                               scale (0.7::GLfloat) 0.7 0.7
>                               translate $ Vector3 (-1.3) py 0.0
>                               drawTree (populateTree (makeTree (px-(k1 px)*(2^maxHeight))) (newseed (k1 px) g) (fromIntegral maxHeight) (0,0,E_Tree) (initTree (k1 px)))  
>                                            (Vertex2 (1.3+1.25*offset-(fromIntegral px)*0.0375+(k1 px)*2.4) (2.3)) 
>                                            0.6 t
>                               mstripdata<-drawTree (populateTree (makeTree (px-(k2 px)*(2^maxHeight))) (newseed (k2 px) g) (fromIntegral maxHeight) (0,0,E_Tree) (initTree  (k2 px)) ) 
>                                           (Vertex2 (1.3+1.25*offset-(fromIntegral px)*0.0375+(k2 px)*2.4) (2.3)) 
>                                           0.6 t
>                               drawTree (populateTree (makeTree (px-(k3 px)*(2^maxHeight))) (newseed (k3 px) g) (fromIntegral maxHeight) (0,0,E_Tree) (initTree  (k3 px)) ) 
>                                            (Vertex2 (1.3+1.25*offset-(fromIntegral px)*0.0375+(k3 px)*2.4) (2.3)) 
>                                            0.6 t
>                               renderPrimitive Polygon $ do
>                                                         color $ if alive mstripdata py t then white
>                                                                 else red
>                                                         vertex $ Vertex2 (1.3+0.037) (-py+0.0375)
>                                                         vertex $ Vertex2 (1.3+0.037+0.0275) (-py+0.0375)
>                                                         vertex $ Vertex2 (1.3+0.037+0.0275) (-py-0.0375)
>                                                         vertex $ Vertex2 (1.3+0.037) (-py-0.0375)

>                               if (alive mstripdata py t )
>                                   then return()
>                                   else do
>                                        modifyIORef gamestate (\gs->initialState (shuffle g) False (max s ms))
>                                        Musicwrapper.play_crash

>            translate $ Vector3 (-0.9) (0.85::GLfloat) 0.0
>            scale (0.0003::GLfloat) 0.0003 0.0003
>            renderString MonoRoman (show s)

            translate $ Vector3 (0) (-100::GLfloat) 0.0

>            translate $ Vector3 (-100) (200::GLfloat) 0.0
>            color $ Color3 0.7 0.7 (0.7::GLfloat)
>            renderString MonoRoman (show ms)
>   swapBuffers
>     where 
>     k1 x = fromIntegral (x `div` (2^(maxHeight))) -1
>     k2 x = fromIntegral (x `div` (2^(maxHeight))) 
>     k3 x = fromIntegral (x `div` (2^(maxHeight))) +1
>     alive x  ay time = case x of
>                               Just (sd@StripData{heights=(top,bottom)}) -> if (-ay+pHeight<top) && (-ay-pHeight>bottom) && (collide sd (-ay) time)
>                                                                            then True
>                                                                            else False
>                               Nothing -> False
>     initTree ax = (ax) 
>     rn g = fst((random g))::Int
>     newseed x g = mkStdGen ((rn g)+x) 

> tick :: IORef (GameState) -> IO()
> tick gamestate = do
>   modifyIORef gamestate (\g@GameState{
>                            player=Entity{
>                                      pos=(px,py),
>                                      velocity=v, 
>                                      engine=e},
>			     time=t,
>                            score=s
>                            }->
>                          g{
>                            player=Entity{
>                                      pos=(px, py+v),
>                                      velocity=if e then if (py>(-3)) then v-0.001
>                                                         else 0
>                                               else v+0.001,
>                                      engine=e
>                            },
>			     time=t+1,
>                            score=max s ((abs (px-2^(maxHeight-1))) `div` 10)})  
>   postRedisplay Nothing
>   addTimerCallback msInterval (tick gamestate)
