> module Entities where
> import Graphics.Rendering.OpenGL
> import System.Random
> import Consts
> import Cube
> import Colors
> import Data.IORef
> import Maths
> import Grid
> import Treestructs2

> data Entity = 
>             Entity { 
>                       pos :: (Int,GLfloat),
>                       velocity :: GLfloat,
>                       engine :: Bool
>                       }

> data GameState = 
>                GameState {	
>                       player:: Entity,
>                       level:: GameLevel,
>                       gen :: StdGen,
>                       time :: GLfloat, -- use to keep track of title-screen progress as well
>                       title :: Bool,
>			score :: Int,
>                       maxscore :: Int
>                       }


> initialState :: StdGen -> Bool -> Int -> GameState
> initialState g t s =  GameState {
>                   player=Entity{pos=(2^(maxHeight-1),-1),velocity=0.005,engine=False},
>                   level=loadLevel level1,
>                   gen=g,
>                   time=0,
>                   title=t,
>                   score=0,
>                   maxscore=s
>                 }

> data EntityType = E_None | E_Tree | E_Waterfall
>                   deriving Eq

> randomEntity ::RandomGen g => g -> EntityType
> randomEntity g = case ((fst(randomR (0::Int,2) g))::Int) of
>                             0  -> E_None
>                             1 -> E_Tree    
>                             2 -> E_Waterfall    

this is code to lock the current state to the spacetime's memory 

> movedir :: Int -> (Int,Int) -> (Int,Int)
> movedir 0 (x,y) = (x,(y+1)`mod`levelsize)
> movedir 1 (x,y) = (x,(y-1)`mod`levelsize)
> movedir 2 (x,y) = ((x-1)`mod`levelsize,y)
> movedir 3 (x,y) = ((x+1)`mod`levelsize,y)
> movedir _ (x,y) = (x,y)

	
