> module Movement where
> import Graphics.Rendering.OpenGL
> import Graphics.UI.GLUT
> import Data.IORef
> import Entities
> import Grid


> moveEntities :: GameLevel -> [Entity] -> [Entity]
> moveEntities l es = [move e l e| e<-es]

> innerMovement ::  GameState -> GameState
> innerMovement  g = g{entity=moveEntities  (level g)  $ entity g }

> doMovement ::  IORef(GameState) -> IO ()
> doMovement gamestate = do
>                        modifyIORef gamestate innerMovement


> collideEntities :: [Entity] -> [Entity]
> collideEntities es = [(collide e) e es| e<-es]

> innerCollision :: GameState -> GameState
> innerCollision g = g{entity=collideEntities $ entity g }

> doCollision :: IORef(GameState) -> IO()
> doCollision gamestate = do
>                         modifyIORef gamestate innerCollision