module Treepopulate where

import Graphics.Rendering.OpenGL
import Graphics.Rendering.OpenGL.GL.StateVar
import Graphics.UI.GLUT
import System.Random
import Treestructs2
import Entities

minHeight :: GLfloat
minHeight = 0.1


-- NEED A FUNCTION treefromlist :: Tree Int -> [(GLfloat, GLfloat, EntityType)] -> Tree (GLfloat, GLfloat, EntityType)!
-- will need to keep track of height and x coord... (so should be able to get from thing directly?
-- treefromList fork = id
-- treefromlist Label a = list!! a ... or an average of a range depending on the height
-- treefromlist Player a = list !! a

populateTree :: RandomGen g => Tree a -> g -> GLfloat -> (GLfloat,GLfloat,EntityType) -> Int -> Tree (GLfloat, GLfloat, EntityType)
populateTree (Fork a tb tc) g h (parenty1, parenty2,ent) roomnum = Fork (parenty1, parenty2,ent)
                                           (populateTree tb g4 (h-1) (newy1a,newy1b,leftent) roomnum) 
                                           (populateTree tc g6 (h-1) (newy2a,newy2b,rightent) roomnum)
    where
--      (y1,g1) = randomR (-0.1,0.1) g
--      (y2,g2) = randomR (-0.1,0.1) g1
      (y1,g1) = randomR (-h/20-0.01,h/20+0.01) g
      (y2,g2) = randomR (-h/20-0.01,h/20+0.01) g1
      (g3,g4) = split g1
      (g5,g6) = split g3
      (g7,g8) = split g5
      (g9,g10) = split g7
      (leftent,rightent) = case ((fst(randomR (-1::Int,1) g8))::Int) of
                             (-1) -> (ent,randomEntity g7)
                             0  -> (ent, ent)
                             1 -> (randomEntity g7 ,ent)                               
      prospy1a = parenty1+y1
      prospy1b = parenty1-y1
      prospy2a = parenty2+y2
      prospy2b = parenty2-y2
      (newy1a,newy1b) = if (prospy1a+prospy1b>minHeight*2)
              then (prospy1a,prospy1b)
              else (minHeight*2+prospy1a,minHeight*2+prospy1b)
      (newy2a,newy2b) = if (prospy2a+prospy2b>minHeight*2)
              then (prospy2a,prospy2b)
              else (minHeight*2+prospy2a,minHeight*2+prospy2b)

populateTree (Leaf a) g h parenty@(ptop,pbottom,ent) roomnum = if (roomnum==0)  
                                                                 then Leaf (100,pbottom,E_None)
                                                                 else if (roomnum `mod` 3 == 0)
                                                                      then Leaf (0.5+ptop,0.5+pbottom,ent)
                                                                      else if (roomnum `mod` 5 == 0)
                                                                           then if (fst(random g)) 
                                                                                then Leaf (ptop,2+pbottom,ent)
                                                                                else Leaf (ptop,pbottom,ent)   
                                                                           else if (roomnum `mod` 7 ==0)
                                                                                then Leaf (ptop*2,pbottom,E_Waterfall)
                                                                                else if (roomnum `mod` 11 ==0)
                                                                                     then Leaf (ptop/2,pbottom/2,E_None)      
                                                                                     else if (roomnum `mod` 13 ==0)
                                                                                          then Leaf (0.5+ptop/20,0.5+pbottom/20,ent)      
                                                                                          else Leaf (ptop,pbottom,ent)
populateTree (Player a) g h parenty@(ptop,pbottom,ent) roomnum = if (roomnum==0)  
                                                                 then Player (100,pbottom,E_None)
                                                                 else if (roomnum `mod` 3 == 0)
                                                                      then Player (0.5+ptop,0.5+pbottom,ent)
                                                                      else if (roomnum `mod` 5 == 0)
                                                                           then if (fst(random g)) 
                                                                                then Player (ptop,2+pbottom,ent)
                                                                                else Player (ptop,pbottom,ent)   
                                                                           else if (roomnum `mod` 7 ==0)
                                                                                then Player (ptop*2,pbottom,E_Waterfall)
                                                                                else if (roomnum `mod` 11 ==0)
                                                                                     then Player (ptop/2,pbottom/2,E_None)      
                                                                                     else if (roomnum `mod` 13 ==0)
                                                                                          then Player (0.5+ptop/20,0.5+pbottom/20,ent)      
                                                                                          else Player (ptop,pbottom,ent)