#include <termios.h>
#include "stdio.h"
#include "musicback.h"

#include "fmod/fmod.h"
#include "fmod/fmod_errors.h"


	FMOD_SYSTEM* fmod_system;
	FMOD_SOUND* fmod_music;
	FMOD_SOUND* fmod_crash;
	FMOD_CHANNEL* channel1 = 0;
	FMOD_CHANNEL* channel2 = 0;
	unsigned int      version;

#ifdef __APPLE__
char* musicpath = "../Resources/Sound/music.xm";
char* crashpath = "../Resources/Sound/crash.wav";
#else
char* musicpath = "Sound/music.xm";
char* crashpath = "Sound/crash.wav";
#endif

void
init_sound()
{
FMOD_System_Create(&(fmod_system));
FMOD_System_GetVersion(fmod_system, &version);
FMOD_System_Init(fmod_system, 3, FMOD_INIT_NORMAL, NULL);
FMOD_System_CreateSound(fmod_system,musicpath, FMOD_SOFTWARE | FMOD_2D | FMOD_LOOP_NORMAL, 0, &(fmod_music));
FMOD_System_CreateSound(fmod_system,crashpath, FMOD_SOFTWARE | FMOD_2D | FMOD_LOOP_OFF, 0, &(fmod_crash));
FMOD_System_PlaySound(fmod_system, FMOD_CHANNEL_FREE, fmod_music, 0, &channel1);
}

void
release_sound()
{
FMOD_Sound_Release(fmod_crash);
FMOD_Sound_Release(fmod_music);
FMOD_System_Close(fmod_system);
FMOD_System_Release(fmod_system);
}

void
play_crash()
{
FMOD_System_PlaySound(fmod_system, FMOD_CHANNEL_FREE, fmod_crash, 0, &channel2);
}
